'use strict';

/*
Usage:
new FileWriterWebpackPlugin(compilation, callback => callback(null, {
  'write-this-file.html': '<html></html>'
}))
*/

var RawSource = require('webpack-sources/lib/RawSource');

var FileWriterWebpackPlugin = function FileWriterWebpackPlugin(getFiles, callback) {
  this.getFiles = getFiles;
};

FileWriterWebpackPlugin.prototype.apply = function (compiler) {
  var _this = this;

  compiler.plugin('this-compilation', function (compilation) {
    compilation.plugin('optimize-assets', function (_, done) {
      _this.getFiles(compilation, function (err, files) {
        if (err) {
          console.log(err);
          compilation.errors.push(err);
        } else {
          Object.keys(files).forEach(function (filename) {
            compilation.assets[filename] = new RawSource(files[filename]);
          });
        }

        done();
      });
    });
  });
};

module.exports = FileWriterWebpackPlugin;