'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _history = require('history');

var _Provider = require('./components/Provider');

var _Provider2 = _interopRequireDefault(_Provider);

var _defaults = require('./config/defaults');

var _defaults2 = _interopRequireDefault(_defaults);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Provided through webpack resolve alias in webpack.config.js
var config = (0, _defaults2.default)(require('config'));

var history = (0, _history.createBrowserHistory)();

var content = JSON.parse(window.content || '{}');
var scripts = JSON.parse(window.scripts || '{}');
var routes = config.routes(content);

function route() {
  var pathname = history.location.pathname;
  var route = routes.find(function (route) {
    return route.path === pathname;
  }) || config.notFoundRoute;
  var component = route.component,
      title = route.title;


  _reactDom2.default.render(_react2.default.createElement(_Provider2.default, {
    title: title,
    content: content,
    config: config,
    scripts: scripts,
    history: history,
    children: component
  }), root);
}

history.listen(route);
window.addEventListener('load', route);