'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  button: {
    display: 'inline-block',
    verticalAlign: 'middle',
    border: 0,
    color: 'white',
    fontSize: '1em',
    padding: '0.6em 1em',
    background: _constants.colors.button.background,
    boxShadow: 'inset 0 0 0 1px rgba(0, 0, 0, 0.15)',
    boxSizing: 'border-box',
    borderRadius: 1,
    outline: 0,
    cursor: 'pointer',
    margin: '0.5em 0.25em'
  },

  buttonSecondary: {
    background: 'rgba(255, 255, 255, 0.12)',
    boxShadow: '0 0 0 1px rgba(0, 0, 0, 0.2)'
  },

  block: {
    display: 'block',
    width: '100%',
    margin: '0.5em 0'
  },

  hover: {
    primary: {
      background: _constants.colors.button.backgroundHover
    },

    secondary: {
      background: 'rgba(255, 255, 255, 0.15)'
    }
  },

  pressed: {
    primary: {
      background: _constants.colors.button.backgroundPressed,
      boxShadow: 'inset 0 0 0 1px rgba(0, 0, 0, 0.2), inset 0 3px 0 0 rgba(0, 0, 0, 0.2)'
    },

    secondary: {
      background: 'rgba(255, 255, 255, 0.1)',
      boxShadow: 'inset 0 0 0 1px rgba(0, 0, 0, 0.2), inset 0 3px 0 0 rgba(0, 0, 0, 0.2)'
    }
  },

  inverted: {
    color: 'black'
  }
};

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.onMouseUp = _this.onMouseUp.bind(_this);

    _this.state = {
      focused: false,
      hover: false,
      pressed: false
    };
    return _this;
  }

  _createClass(Button, [{
    key: 'toggleFocus',
    value: function toggleFocus() {
      this.setState({
        focused: !this.state.focused
      });
    }
  }, {
    key: 'toggleHover',
    value: function toggleHover() {
      this.setState({
        focused: !this.state.focused,
        hover: !this.state.hover
      });
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown() {
      this.setState({
        pressed: true
      });

      document.addEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      this.setState({
        pressed: false
      });

      document.removeEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          hover = _state.hover,
          pressed = _state.pressed;
      var _props = this.props,
          label = _props.label,
          submit = _props.submit,
          block = _props.block,
          onClick = _props.onClick,
          secondary = _props.secondary,
          inverted = _props.inverted;


      var buttonStyle = _extends({}, styles.button, secondary && styles.buttonSecondary, hover && styles.hover[secondary ? 'secondary' : 'primary'], hover && pressed && styles.pressed[secondary ? 'secondary' : 'primary'], block && styles.block, inverted && styles.inverted, this.props.style);

      var props = {
        style: buttonStyle,
        onMouseDown: this.onMouseDown.bind(this),
        onMouseUp: this.onMouseUp.bind(this),
        onMouseEnter: this.toggleHover.bind(this),
        onMouseLeave: this.toggleHover.bind(this),
        onFocus: this.toggleFocus.bind(this),
        onBlur: this.toggleFocus.bind(this),
        onClick: onClick
      };

      if (submit) {
        return _react2.default.createElement('input', _extends({ type: 'submit', value: label }, props));
      } else {
        return _react2.default.createElement(
          'button',
          props,
          label
        );
      }
    }
  }]);

  return Button;
}(_react2.default.Component);

Button.propTypes = {
  label: _react2.default.PropTypes.string,
  submit: _react2.default.PropTypes.bool,
  onClick: _react2.default.PropTypes.func,
  block: _react2.default.PropTypes.bool,
  secondary: _react2.default.PropTypes.bool,
  inverted: _react2.default.PropTypes.bool,
  style: _react2.default.PropTypes.object
};
exports.default = Button;