'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = exports.DropdownContent = exports.DropdownToggle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  container: {
    position: 'relative'
  },

  toggle: {
    cursor: 'pointer'
  },

  content: {
    position: 'absolute',
    top: '100%',
    right: '0'
  }
};

var DropdownToggle = exports.DropdownToggle = function DropdownToggle(_ref) {
  var children = _ref.children,
      style = _ref.style;
  return _react2.default.createElement(
    'div',
    { style: style },
    children
  );
};

var DropdownContent = exports.DropdownContent = function DropdownContent(_ref2) {
  var children = _ref2.children,
      style = _ref2.style;
  return _react2.default.createElement(
    'div',
    { style: style },
    children
  );
};

var Dropdown = exports.Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.closeIfOutside = _this.closeIfOutside.bind(_this);

    _this.state = {
      open: props.open
    };
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if ('open' in nextProps) {
        this.setState({
          open: nextProps.open
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: 'open',
    value: function open() {
      this.setState({ open: true });
      document.addEventListener('mousedown', this.closeIfOutside);
      this.props.onToggle && this.props.onToggle(true);
    }
  }, {
    key: 'close',
    value: function close() {
      this.setState({ open: false });
      document.removeEventListener('mousedown', this.closeIfOutside);
      this.props.onToggle && this.props.onToggle(false);
    }
  }, {
    key: 'closeIfOutside',
    value: function closeIfOutside(e) {
      if (this.mounted && !this.DOMElement.contains(e.target)) {
        this.close();
      }
    }
  }, {
    key: 'setDOMElement',
    value: function setDOMElement(DOMElement) {
      this.DOMElement = DOMElement;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = _react2.default.Children.toArray(this.props.children);
      var open = this.state.open;

      var toggle = this[open ? 'close' : 'open'].bind(this);

      var containerStyle = _extends({}, styles.container, this.props.style);

      var toggleComponent = (0, _lodash.find)(children, function (child) {
        return child.type === DropdownToggle;
      });
      var contentComponent = (0, _lodash.find)(children, function (child) {
        return child.type === DropdownContent;
      });

      return _react2.default.createElement(
        'div',
        { ref: this.setDOMElement.bind(this), style: containerStyle },
        _react2.default.createElement(
          'div',
          { style: styles.toggle, onClick: toggle },
          toggleComponent
        ),
        open && _react2.default.createElement(
          'div',
          { style: styles.content },
          contentComponent
        )
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  open: _react2.default.PropTypes.bool,
  onToggle: _react2.default.PropTypes.func,
  children: _react2.default.PropTypes.any,
  style: _react2.default.PropTypes.object
};
Dropdown.defaultProps = {
  open: false
};