'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _Message = require('./Message');

var _Message2 = _interopRequireDefault(_Message);

var _Window = require('./Window');

var _Window2 = _interopRequireDefault(_Window);

var _WindowHeader = require('./WindowHeader');

var _WindowHeader2 = _interopRequireDefault(_WindowHeader);

var _SignIn = require('./SignIn');

var _SignIn2 = _interopRequireDefault(_SignIn);

var _Toolbar = require('./Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _authentication = require('../../actions/authentication');

var _content = require('../../actions/content');

var _editor = require('../../actions/editor');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  editor: {
    color: 'white',
    fontFamily: '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif'
  },

  contentPushedDown: {
    position: 'relative',
    paddingTop: 50
  }
};

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor() {
    _classCallCheck(this, Editor);

    return _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).apply(this, arguments));
  }

  _createClass(Editor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.context.flatpack.store.dispatch((0, _authentication.fetchCredentials)());
    }
  }, {
    key: 'hasChanges',
    value: function hasChanges() {
      var _context$flatpack$sto = this.context.flatpack.store.getState().content,
          session = _context$flatpack$sto.session,
          published = _context$flatpack$sto.published;

      return !session.equals(published);
    }
  }, {
    key: 'publish',
    value: function publish() {
      var _context$flatpack = this.context.flatpack,
          store = _context$flatpack.store,
          config = _context$flatpack.config,
          scripts = _context$flatpack.scripts;

      var _store$getState = store.getState(),
          authentication = _store$getState.authentication,
          content = _store$getState.content;

      var session = content.session;
      var credentials = authentication.credentials;

      var uploads = (0, _lodash.flatten)((0, _lodash.map)(content.uploads, function (upload) {
        return upload.files;
      }));

      this.context.flatpack.store.dispatch((0, _editor.publish)({
        content: session.toJS(),
        credentials: credentials,
        config: config,
        scripts: scripts,
        uploads: uploads
      }));
    }
  }, {
    key: 'discard',
    value: function discard() {
      if (window.confirm('Are you sure you want to discard all changes?')) {
        this.context.flatpack.store.dispatch((0, _content.discard)());
      }
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      var state = this.context.flatpack.store.getState();
      var credentials = state.authentication.credentials;
      var _state$editor = state.editor,
          publishing = _state$editor.publishing,
          building = _state$editor.building,
          uploading = _state$editor.uploading,
          releasing = _state$editor.releasing;


      if (credentials === null) {
        return _react2.default.createElement(
          _Message2.default,
          null,
          'Getting authentication\u2026'
        );
      }

      if (credentials === false) {
        return _react2.default.createElement(
          _Window2.default,
          null,
          _react2.default.createElement(
            _WindowHeader2.default,
            null,
            'Login'
          ),
          _react2.default.createElement(_SignIn2.default, null)
        );
      }

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_Toolbar2.default, {
          changes: this.hasChanges(),
          discard: this.discard.bind(this),
          publish: this.publish.bind(this)
        }),
        publishing && _react2.default.createElement(
          _Message2.default,
          null,
          'Publishing\u2026'
        ),
        building && _react2.default.createElement(
          _Message2.default,
          null,
          'Building\u2026'
        ),
        uploading && _react2.default.createElement(
          _Message2.default,
          null,
          'Uploading\u2026'
        ),
        releasing && _react2.default.createElement(
          _Message2.default,
          null,
          'Releasing\u2026'
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var state = this.context.flatpack.store.getState();
      var credentials = state.authentication.credentials;

      var contentStyles = credentials && styles.contentPushedDown || {};

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: styles.editor },
          this.renderEditor()
        ),
        _react2.default.createElement(
          'div',
          { style: contentStyles },
          this.props.children
        )
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

Editor.propTypes = {
  children: _react2.default.PropTypes.node
};
Editor.defaultProps = {
  editing: false
};
Editor.contextTypes = {
  flatpack: _react2.default.PropTypes.object.isRequired
};
exports.default = Editor;