'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  container: {
    display: 'block',
    position: 'relative',
    border: '1px solid',
    borderColor: _constants.colors.input.border,
    borderRadius: 2,
    margin: '0.75em 0',
    lineHeight: 1,
    background: _constants.colors.input.background
  },

  input: {
    fontSize: '1em',
    padding: '1.25em 0.5em 0.5em',
    border: 0,
    outline: 0,
    color: _constants.colors.input.text,
    background: 'transparent',
    width: '100%'
  },

  label: {
    position: 'absolute',
    top: '0.925em',
    left: '0.5em',
    color: _constants.colors.input.label,
    pointerEvents: 'none'
  },

  labelSmall: {
    fontSize: '0.65em',
    top: '0.7em',
    left: '0.8em',
    textTransform: 'uppercase',
    fontWeight: 500,
    letterSpacing: '0.082em'
  },

  labelFocused: {
    color: _constants.colors.input.focused
  },

  containerFocused: {
    borderColor: _constants.colors.input.focused,
    background: _constants.colors.input.backgroundFocused
  }
};

var Input = function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      focused: false
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: 'onToggleFocus',
    value: function onToggleFocus(e) {
      this.setState({
        focused: e.target === document.activeElement
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          onChange = _props.onChange,
          value = _props.value,
          mask = _props.mask,
          name = _props.name,
          type = _props.type;
      var focused = this.state.focused;


      var containerStyle = _extends({}, styles.container, focused && styles.containerFocused);

      var labelStyle = _extends({}, styles.label, focused && styles.labelFocused, (focused || value) && styles.labelSmall);

      return _react2.default.createElement(
        'label',
        { style: containerStyle },
        _react2.default.createElement(
          'div',
          { style: labelStyle },
          label
        ),
        _react2.default.createElement('input', {
          name: name,
          style: styles.input,
          type: mask ? 'password' : type,
          value: value,
          onChange: onChange,
          onFocus: this.onToggleFocus.bind(this),
          onBlur: this.onToggleFocus.bind(this),
          onInput: this.onToggleFocus.bind(this)
        })
      );
    }
  }]);

  return Input;
}(_react2.default.Component);

Input.propTypes = {
  label: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  value: _react2.default.PropTypes.string.isRequired,
  mask: _react2.default.PropTypes.bool,
  name: _react2.default.PropTypes.string,
  type: _react2.default.PropTypes.string
};
Input.defaultProps = {
  type: 'text'
};
exports.default = Input;