'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _authentication = require('../../actions/authentication');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  container: {
    minWidth: '18em',
    maxWidth: '22em',
    margin: 0
  },

  header: {
    fontSize: '1em',
    height: '4em'
  },

  button: {
    margin: '1.5em 0'
  }
};

var SignIn = function (_React$Component) {
  _inherits(SignIn, _React$Component);

  function SignIn(props) {
    _classCallCheck(this, SignIn);

    var _this = _possibleConstructorReturn(this, (SignIn.__proto__ || Object.getPrototypeOf(SignIn)).call(this, props));

    _this.onUsernameChange = _this.onInputChange.bind(_this, 'username');
    _this.onPasswordChange = _this.onInputChange.bind(_this, 'password');

    _this.state = {
      username: '',
      password: ''
    };
    return _this;
  }

  _createClass(SignIn, [{
    key: 'onSubmit',
    value: function onSubmit(e) {
      e.preventDefault();
      var _state = this.state,
          username = _state.username,
          password = _state.password;

      this.context.flatpack.store.dispatch((0, _authentication.signIn)(username, password));
    }
  }, {
    key: 'onInputChange',
    value: function onInputChange(key, e) {
      this.setState(_defineProperty({}, key, e.currentTarget.value));
    }
  }, {
    key: 'onShowPasswordChange',
    value: function onShowPasswordChange(e) {
      this.setState({
        showPassword: e.currentTarget.checked
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _context$flatpack$sto = this.context.flatpack.store.getState().authentication,
          signingIn = _context$flatpack$sto.signingIn,
          error = _context$flatpack$sto.error;
      var _state2 = this.state,
          username = _state2.username,
          password = _state2.password;


      return _react2.default.createElement(
        'form',
        { style: styles.container, onSubmit: this.onSubmit.bind(this) },
        false && _react2.default.createElement(
          'h3',
          { style: styles.header },
          'Log in'
        ),
        _react2.default.createElement(_Input2.default, { name: 'email', type: 'email', value: username, label: 'Email', onChange: this.onUsernameChange.bind(this) }),
        _react2.default.createElement(_Input2.default, { name: 'password', mask: true, value: password, label: 'Password', onChange: this.onPasswordChange.bind(this) }),
        _react2.default.createElement(_Button2.default, { block: true, submit: true, style: styles.button, label: signingIn ? 'Signing in…' : 'Sign in' }),
        error && _react2.default.createElement(
          'div',
          null,
          error.toString()
        )
      );
    }
  }]);

  return SignIn;
}(_react2.default.Component);

SignIn.contextTypes = {
  flatpack: _react2.default.PropTypes.object
};
exports.default = SignIn;