'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var width = '2.8em';
var height = '1.7em';
var knobMargin = 4;

var styles = {
  container: {
    padding: '0.5em 0',
    margin: '0.3em',
    cursor: 'pointer',
    userSelect: 'none',
    display: 'inline-block'
  },

  switch: {
    background: _constants.colors.switch.background,
    boxShadow: 'inset 0 0 0 1px rgba(0, 0, 0, 0.2)',
    width: width,
    height: height,
    borderRadius: height,
    display: 'inline-block',
    verticalAlign: 'middle',
    position: 'relative',
    marginTop: '-0.15em'
  },

  switchActive: {
    background: _constants.colors.switchActive.background,
    boxShadow: 'inset 0 0 0 1px rgba(0, 0, 0, 0.6)',
    borderColor: _constants.colors.switchActive.border
  },

  knob: {
    background: _constants.colors.switch.knob.background,
    display: 'block',
    position: 'absolute',
    top: knobMargin,
    left: knobMargin,
    boxSizing: 'border-box',
    width: 'calc(' + height + ' - ' + knobMargin * 2 + 'px)',
    height: 'calc(' + height + ' - ' + knobMargin * 2 + 'px)',
    borderRadius: '50%',
    boxShadow: '0 0.5px 0 1px rgba(0, 0, 0, 0.3)',
    transition: 'left 0.1s ease-in 0s, background 0.1s ease-in 0s'
  },

  knobActive: {
    left: 'calc(100% - ' + height + ' + ' + knobMargin + 'px)'
  },

  label: {
    marginLeft: '0.5em'
  }
};

var Switch = function (_React$Component) {
  _inherits(Switch, _React$Component);

  function Switch() {
    _classCallCheck(this, Switch);

    return _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).apply(this, arguments));
  }

  _createClass(Switch, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          onClick = _props.onClick,
          checked = _props.checked;


      var switchStyle = _extends({}, styles.switch, checked && styles.switchActive);

      var knobStyle = _extends({}, styles.knob, checked && styles.knobActive);

      return _react2.default.createElement(
        'div',
        { style: styles.container, onClick: onClick },
        _react2.default.createElement(
          'span',
          { style: switchStyle },
          _react2.default.createElement('span', { style: knobStyle })
        ),
        _react2.default.createElement(
          'span',
          { style: styles.label },
          label
        )
      );
    }
  }]);

  return Switch;
}(_react2.default.Component);

Switch.propTypes = {
  label: _react2.default.PropTypes.string,
  checked: _react2.default.PropTypes.bool,
  onClick: _react2.default.PropTypes.func
};
Switch.defaultProps = {
  checked: false
};
exports.default = Switch;