'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Switch = require('./Switch');

var _Switch2 = _interopRequireDefault(_Switch);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dropdown = require('./Dropdown');

var _constants = require('./constants');

var _editor = require('../../actions/editor');

var _authentication = require('../../actions/authentication');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  menu: {
    background: '#5B5E6C',
    fontSize: '0.875em',
    position: 'fixed',
    display: 'flex',
    left: 0,
    top: 0,
    right: 0,
    zIndex: 10,
    alignItems: 'stretch',
    justifyContent: 'flex-end',
    border: '1px solid ' + _constants.colors.darkSlate.setAlpha(0.5)
  },

  toggle: {
    width: '50px',
    height: '50px',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    cursor: 'pointer',
    borderLeft: '1px solid',
    borderLeftColor: _constants.colors.darkSlate.setAlpha(0.5)
  },

  toggleActive: {
    background: _constants.colors.darkSlate,
    borderLeftColor: _constants.colors.darkSlate
  },

  logo: {
    fill: _constants.colors.darkSlate,
    flex: 'auto',
    pointerEvents: 'none'
  },

  logoActive: {
    fill: 'white'
  },

  dropdown: {
    flexGrow: 0
  },

  dropdownContent: {
    background: _constants.colors.darkSlate
  },

  tools: {
    flex: 'auto',
    display: 'flex',
    alignItems: 'middle',
    justifyContent: 'space-between'
  },

  toolGroup: {
    flex: 'auto',
    flexGrow: 0,
    display: 'flex',
    padding: '0 0.5em',
    alignItems: 'center'
  },

  menuLink: {
    display: 'block',
    cursor: 'pointer',
    padding: '0.875em'
  }
};

var Toolbar = function (_React$Component) {
  _inherits(Toolbar, _React$Component);

  function Toolbar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Toolbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Toolbar.__proto__ || Object.getPrototypeOf(Toolbar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      dropdownActive: false
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toolbar, [{
    key: 'onSignOut',
    value: function onSignOut() {
      this.context.flatpack.store.dispatch((0, _authentication.signOut)());
    }
  }, {
    key: 'toggleDropdown',
    value: function toggleDropdown(toggle) {
      this.setState({
        dropdownActive: toggle
      });
    }
  }, {
    key: 'toggleEdit',
    value: function toggleEdit() {
      this.context.flatpack.store.dispatch((0, _editor.toggleEditing)());
    }
  }, {
    key: 'render',
    value: function render() {
      var state = this.context.flatpack.store.getState();
      var editing = state.editor.editing;
      var credentials = state.authentication.credentials;
      var dropdownActive = this.state.dropdownActive;
      var _props = this.props,
          changes = _props.changes,
          discard = _props.discard,
          publish = _props.publish;


      var toggleStyle = _extends({}, styles.toggle, dropdownActive && styles.toggleActive);

      var logoStyle = _extends({}, styles.logo, dropdownActive && styles.logoActive);

      return _react2.default.createElement(
        'div',
        { style: styles.menu },
        credentials && _react2.default.createElement(
          'div',
          { style: styles.tools },
          _react2.default.createElement(
            'div',
            { style: styles.toolGroup },
            _react2.default.createElement(_Switch2.default, { label: 'Edit', checked: editing, onClick: this.toggleEdit.bind(this) })
          ),
          changes && _react2.default.createElement(
            'div',
            { style: styles.toolGroup },
            _react2.default.createElement(_Button2.default, { secondary: true, onClick: discard, label: 'Discard changes' }),
            _react2.default.createElement(_Button2.default, { onClick: publish, label: 'Publish' })
          )
        ),
        _react2.default.createElement(
          _Dropdown.Dropdown,
          { onToggle: this.toggleDropdown.bind(this), open: dropdownActive },
          _react2.default.createElement(
            _Dropdown.DropdownToggle,
            { style: toggleStyle },
            _react2.default.createElement(
              'svg',
              { style: logoStyle, id: 'logo', width: '20px', height: '20px', viewBox: '0 0 100 100', version: '1.1', xmlns: 'http://www.w3.org/2000/svg' },
              _react2.default.createElement('path', { id: 'umbraco-white', stroke: 'none', fillRule: 'evenodd', d: 'M50,100 C77.6142375,100 100,77.6142375 100,50 C100,22.3857625 77.6142375,0 50,0 C22.3857625,0 0,22.3857625 0,50 C0,77.6142375 22.3857625,100 50,100 Z M50.0449037,12.4 L82.5898074,31.1898089 L82.5898074,68.7694268 L50.0449037,87.5592357 L17.5,68.7694268 L17.5,31.1898089 L50.0449037,12.4 Z' })
            )
          ),
          _react2.default.createElement(
            _Dropdown.DropdownContent,
            { style: styles.dropdownContent },
            _react2.default.createElement(
              'nav',
              null,
              _react2.default.createElement(
                'a',
                { style: styles.menuLink, onClick: this.onSignOut.bind(this) },
                'Sign out ',
                _react2.default.createElement(
                  'small',
                  null,
                  '(',
                  credentials.params.LoginId,
                  ')'
                )
              )
            )
          )
        )
      );
    }
  }]);

  return Toolbar;
}(_react2.default.Component);

Toolbar.propTypes = {
  changes: _react2.default.PropTypes.bool.isRequired,
  discard: _react2.default.PropTypes.func.isRequired,
  publish: _react2.default.PropTypes.func.isRequired
};
Toolbar.contextTypes = {
  flatpack: _react2.default.PropTypes.object
};
exports.default = Toolbar;