'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.colors = undefined;

var _colorJs = require('color-js');

var _colorJs2 = _interopRequireDefault(_colorJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var colors = exports.colors = {
  aqua: new _colorJs2.default('#24b2a1'),
  slate: new _colorJs2.default('#363945'),
  lightGray: new _colorJs2.default('#efefef'),
  silver: new _colorJs2.default('#9c9c9c')
};

colors.darkSlate = colors.slate.darkenByRatio(0.15);

colors.input = {
  text: colors.slate,
  label: 'rgba(0, 0, 0, 0.4)',
  focused: new _colorJs2.default('#408CF5'),
  error: '#C21913',
  border: 'rgba(0, 0, 0, 0.3)',
  background: 'rgba(255, 255, 255, 0.95)',
  backgroundFocused: 'rgba(255, 255, 255, 1)'
};

colors.button = {
  background: colors.aqua,
  backgroundHover: colors.aqua.lightenByRatio(0.04),
  backgroundPressed: colors.aqua.darkenByRatio(0.06)
};

colors.button.secondary = {
  background: colors.silver,
  backgroundHover: colors.silver.lightenByRatio(0.04),
  backgroundPressed: colors.silver.darkenByRatio(0.04)
};

colors.switch = {
  background: 'rgba(0, 0, 0, 0.4)'
};

colors.switch.knob = {
  background: colors.lightGray
};

colors.switchActive = {
  background: colors.aqua,
  border: colors.aqua.darkenByRatio(0.5)
};