'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

var _ContentContainer = require('../ContentContainer');

var _ContentContainer2 = _interopRequireDefault(_ContentContainer);

var _DOMComponent = require('../DOMComponent');

var _DOMComponent2 = _interopRequireDefault(_DOMComponent);

var _createThumbnail = require('./createThumbnail');

var _createThumbnail2 = _interopRequireDefault(_createThumbnail);

var _fileToImage = require('./fileToImage');

var _fileToImage2 = _interopRequireDefault(_fileToImage);

var _createImageVariations = require('./createImageVariations');

var _createImageVariations2 = _interopRequireDefault(_createImageVariations);

var _content = require('../../actions/content');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function isImage(file) {
  return (/^image\//.test(file.type)
  );
}

var styles = {
  container: {
    border: '1px blue solid',
    minHeight: 50,
    minWidth: 50
  },

  dragOver: {
    background: 'yellow'
  }
};

var EditImage = function (_React$Component) {
  _inherits(EditImage, _React$Component);

  function EditImage() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, EditImage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = EditImage.__proto__ || Object.getPrototypeOf(EditImage)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      dragOver: false
    }, _this.onDragOver = function (e) {
      e.stopPropagation();
      e.preventDefault();

      _this.setState({
        dragOver: true
      });
    }, _this.onDragLeave = function (e) {
      _this.setState({
        dragOver: false
      });
    }, _this.onDrop = function (e) {
      e.preventDefault();

      _this.setState({
        dragOver: false
      });

      var file = (0, _lodash.first)(e.dataTransfer.files);

      if (file && isImage(file)) {
        (0, _fileToImage2.default)(file, function (image) {
          (0, _createImageVariations2.default)(file, function (variations) {
            var uploadPath = 'uploads/' + Date.now();

            var uploadAction = (0, _content.setUpload)(_this.props.path, {
              preview: image.src,
              files: variations.map(function (_ref2) {
                var width = _ref2.width,
                    blob = _ref2.blob;
                return {
                  path: uploadPath + '/' + width,
                  data: blob
                };
              })
            });

            var setValueAction = (0, _content.set)(_this.props.path, {
              path: '/' + uploadPath,
              width: image.width,
              height: image.height,
              variations: variations.map(function (variation) {
                return (0, _lodash.pick)(variation, ['width', 'height']);
              }),
              thumbnail: (0, _createThumbnail2.default)(image, 10).src
            });

            _this.context.flatpack.store.dispatch(uploadAction);
            _this.context.flatpack.store.dispatch(setValueAction);
          });
        });
      } else {
        // TODO: Notify user of wrong filetype
        console.log('Not an image');
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(EditImage, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {}
  }, {
    key: 'render',
    value: function render() {
      var dragOver = this.state.dragOver;


      var style = _extends({}, this.props.attrs.style, styles.container, dragOver && styles.dragOver);

      var attrs = _extends({}, this.props.attrs, {
        style: style,
        onDrop: this.onDrop,
        onDragOver: this.onDragOver,
        onDragLeave: this.onDragLeave
      });

      return _react2.default.createElement(
        _DOMComponent2.default,
        _extends({}, this.props, { attrs: attrs }),
        _react2.default.createElement(_Image2.default, { path: this.props.path })
      );
    }
  }]);

  return EditImage;
}(_react2.default.Component);

EditImage.propTypes = {
  path: _react2.default.PropTypes.string.isRequired,
  value: _react2.default.PropTypes.object,
  setValue: _react2.default.PropTypes.func.isRequired,
  attrs: _react2.default.PropTypes.object
};
EditImage.defaultProps = {
  value: {},
  attrs: {}
};
EditImage.contextTypes = {
  flatpack: _react2.default.PropTypes.object
};
exports.default = (0, _ContentContainer2.default)(EditImage);