'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createThumbnail;
var canvas = document.createElement('canvas');
var context = canvas.getContext('2d');

function createThumbnail(image) {
  var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 72;

  var thumbnail = new window.Image();
  var vertical = image.width < image.height;
  var ratio = image.width / image.height;

  canvas.width = vertical ? size * ratio : size;
  canvas.height = vertical ? size : size / ratio;

  context.drawImage(image, 0, 0, canvas.width, canvas.height);

  thumbnail.src = canvas.toDataURL();

  return thumbnail;
}