'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _reactSortableHoc = require('react-sortable-hoc');

var _serialize = require('./serialize');

var _serialize2 = _interopRequireDefault(_serialize);

var _deserialize = require('./deserialize');

var _deserialize2 = _interopRequireDefault(_deserialize);

var _EditContainer = require('./EditContainer');

var _EditContainer2 = _interopRequireDefault(_EditContainer);

var _ContentContainer = require('../ContentContainer');

var _ContentContainer2 = _interopRequireDefault(_ContentContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  container: {
    position: 'relative',
    border: '1px blue solid'
  },

  addButton: {
    position: 'absolute',
    bottom: 0,
    right: 0,
    transform: 'translateY(100%)'
  },

  addButtonReverse: {
    top: 0,
    left: 0,
    bottom: 'auto',
    right: 'auto',
    transform: 'translateY(-100%)'
  }
};

function isDescendantOfContentEditable(node) {
  while (node && node.parentNode) {
    if (node.isContentEditable || node.parentNode.isContentEditable) {
      return true;
    } else {
      node = node.parentNode;
    }
  }
}

var EditList = function (_React$Component) {
  _inherits(EditList, _React$Component);

  function EditList() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, EditList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = EditList.__proto__ || Object.getPrototypeOf(EditList)).call.apply(_ref, [this].concat(args))), _this), _this.onSortEnd = function (_ref2) {
      var oldIndex = _ref2.oldIndex,
          newIndex = _ref2.newIndex;

      var items = (0, _deserialize2.default)(_this.props.value);
      var sorted = (0, _reactSortableHoc.arrayMove)(items, oldIndex, newIndex);

      _this.props.setValue((0, _serialize2.default)(sorted));
    }, _this.onAddClick = function () {
      var _this$props = _this.props,
          reverse = _this$props.reverse,
          value = _this$props.value;

      var modified = (0, _deserialize2.default)(value);

      modified[reverse ? 'unshift' : 'push']({
        key: Date.now().toString(),
        item: {}
      });

      _this.props.setValue((0, _serialize2.default)(modified));
    }, _this.onRemoveItem = function (key) {
      var modified = _extends({}, _this.props.value);
      delete modified[key];
      _this.props.setValue(modified);
    }, _this.shouldCancelStart = function (e) {
      if (isDescendantOfContentEditable(e.target)) {
        return true;
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(EditList, [{
    key: 'renderAddButton',
    value: function renderAddButton() {
      var reverse = this.props.reverse;


      var style = _extends({}, styles.addButton, reverse && styles.addButtonReverse);

      return _react2.default.createElement(
        'button',
        { onClick: this.onAddClick, style: style },
        'Add'
      );
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var _this2 = this;

      var value = this.props.value;

      var render = this.props.children;
      var items = (0, _deserialize2.default)(value);

      return (0, _lodash.map)(items, function (_ref3, index) {
        var item = _ref3.item,
            key = _ref3.key;

        var child = render(key, index);

        return _react2.default.cloneElement(child, _extends({}, child.props, {
          index: index,
          onRemove: function onRemove() {
            return _this2.onRemoveItem(key);
          }
        }));
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var style = _extends({}, styles.container, this.props.attrs.style);

      var attrs = _extends({}, this.props.attrs, {
        style: style
      });

      return _react2.default.createElement(
        _EditContainer2.default,
        _extends({}, this.props, {
          attrs: attrs,
          onSortEnd: this.onSortEnd,
          shouldCancelStart: this.shouldCancelStart,
          distance: 10
        }),
        this.renderChildren(),
        this.renderAddButton()
      );
    }
  }]);

  return EditList;
}(_react2.default.Component);

EditList.propTypes = {
  value: _react2.default.PropTypes.object,
  setValue: _react2.default.PropTypes.func.isRequired,
  children: _react2.default.PropTypes.func.isRequired,
  attrs: _react2.default.PropTypes.object,
  reverse: _react2.default.PropTypes.bool
};
EditList.defaultProps = {
  value: {},
  attrs: {},
  reverse: false
};
exports.default = (0, _ContentContainer2.default)(EditList);