'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deserialize;

var _lodash = require('lodash');

// Deserialized (internal) state:
// [{ key: 'a', value: {}}, { key: 'b', value: {}}]

function deserialize(value) {
  var onlyItems = (0, _lodash.omit)(value, '_order');
  var items = (0, _lodash.map)(onlyItems, function (item, key) {
    return { key: key, item: item };
  });

  return (0, _lodash.sortBy)(items, function (_ref) {
    var item = _ref.item,
        key = _ref.key;
    return (0, _lodash.indexOf)(value._order, key);
  });
}