'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _autosize = require('autosize');

var _autosize2 = _interopRequireDefault(_autosize);

var _ContentContainer = require('../ContentContainer');

var _ContentContainer2 = _interopRequireDefault(_ContentContainer);

var _EditIndicator = require('../EditIndicator');

var _EditIndicator2 = _interopRequireDefault(_EditIndicator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  container: {
    position: 'relative',
    display: 'block'
  },

  text: {
    position: 'relative',
    outline: 0,
    zIndex: 4
  },

  input: {
    all: 'inherit'
  }
};

var EditPlainText = function (_React$Component) {
  _inherits(EditPlainText, _React$Component);

  function EditPlainText() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, EditPlainText);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = EditPlainText.__proto__ || Object.getPrototypeOf(EditPlainText)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (e) {
      _this.props.setValue(e.target.value.replace(/\n/gi, ' '));
    }, _this.onKeyDown = function (e) {
      if (e.keyCode === 13) {
        e.preventDefault();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(EditPlainText, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      (0, _autosize2.default)(_reactDom2.default.findDOMNode(this.refs.textarea));
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _autosize2.default.destroy(_reactDom2.default.findDOMNode(this.refs.textarea));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          placeholder = _props.placeholder;


      return _react2.default.createElement(
        _EditIndicator2.default,
        null,
        _react2.default.createElement(
          'span',
          { style: styles.container },
          _react2.default.createElement('textarea', {
            style: styles.input,
            placeholder: placeholder,
            onChange: this.onChange,
            onKeyDown: this.onKeyDown,
            ref: 'textarea',
            value: value,
            rows: 1
          })
        )
      );
    }
  }]);

  return EditPlainText;
}(_react2.default.Component);

EditPlainText.propTypes = {
  value: _react2.default.PropTypes.string,
  setValue: _react2.default.PropTypes.func.isRequired,
  placeholder: _react2.default.PropTypes.string
};
EditPlainText.defaultProps = {
  placeholder: ''
};
exports.default = (0, _ContentContainer2.default)(EditPlainText);