'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _createStore = require('../createStore');

var _createStore2 = _interopRequireDefault(_createStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Provider = function (_React$Component) {
  _inherits(Provider, _React$Component);

  _createClass(Provider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        flatpack: {
          config: this.props.config,
          content: this.props.content,
          scripts: this.props.scripts,
          history: this.props.history,
          store: this.store
        }
      };
    }
  }]);

  function Provider(props) {
    _classCallCheck(this, Provider);

    var _this = _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props));

    _this.state = {
      Editor: null
    };


    _this.store = (0, _createStore2.default)({
      content: {
        session: (0, _immutable.fromJS)(props.content),
        published: (0, _immutable.fromJS)(props.content),
        uploads: {}
      }
    });

    _this.store.subscribe(_this.forceUpdate.bind(_this));
    return _this;
  }

  _createClass(Provider, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.checkForEditor();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.checkForEditor();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      document.title = nextProps.title;
    }
  }, {
    key: 'checkForEditor',
    value: function checkForEditor() {
      var _this2 = this;

      if (!this.state.Editor && this.store.getState().app.editor) {
        require.ensure('./Editor', function (require) {
          _this2.setState({
            Editor: require('./Editor').default
          });
        }, 'editor');
      }
    }
  }, {
    key: 'renderChild',
    value: function renderChild() {
      return _react2.default.Children.only(this.props.children);
    }
  }, {
    key: 'render',
    value: function render() {
      var Editor = this.state.Editor;
      var editor = this.store.getState().app.editor;


      if (editor && Editor) {
        return _react2.default.createElement(
          Editor,
          null,
          this.renderChild()
        );
      } else {
        return this.renderChild();
      }
    }
  }]);

  return Provider;
}(_react2.default.Component);

Provider.propTypes = {
  config: _react2.default.PropTypes.object.isRequired,
  content: _react2.default.PropTypes.object.isRequired,
  scripts: _react2.default.PropTypes.array.isRequired,
  children: _react2.default.PropTypes.element.isRequired,
  history: _react2.default.PropTypes.object
};
Provider.childContextTypes = {
  flatpack: _react2.default.PropTypes.object
};
exports.default = Provider;