'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPortal = require('react-portal');

var _reactPortal2 = _interopRequireDefault(_reactPortal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  menuWrapper: {
    zIndex: 5,
    position: 'absolute',
    fontFamily: 'Iosevka, monospaced'
  },

  menu: {
    background: '#5B5E6D',
    border: '1px solid #414554',
    borderRadius: '2px',
    display: 'flex'
  },

  formatButton: {
    width: 32,
    height: 32,
    lineHeight: '32px',
    textAlign: 'center',
    color: 'rgba(255, 255, 255, 0.7)',
    cursor: 'pointer',
    flex: 1
  },

  formatButtonHover: {
    color: 'white'
  },

  formatButtonActive: {
    color: 'white',
    background: '#414554'
  }
};

var FormatMenu = function (_React$Component) {
  _inherits(FormatMenu, _React$Component);

  function FormatMenu() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FormatMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormatMenu.__proto__ || Object.getPrototypeOf(FormatMenu)).call.apply(_ref, [this].concat(args))), _this), _this.renderMarkButton = function (type, icon) {
      var isActive = _this.props.hasMark(type);
      var onMouseDown = function onMouseDown(e) {
        return _this.props.onMarkButtonClick(e, type);
      };

      var style = _extends({}, styles.formatButton, isActive && _extends({}, styles.formatButtonActive));

      return _react2.default.createElement(
        'span',
        { onMouseDown: onMouseDown, style: style },
        _react2.default.createElement(
          'span',
          null,
          icon
        )
      );
    }, _this.renderLinkButton = function (type, icon) {
      var isActive = _this.props.hasLink();
      var onMouseDown = function onMouseDown(e) {
        return _this.props.onLinkButtonClick(e, type);
      };

      var style = _extends({}, styles.formatButton, isActive && _extends({}, styles.formatButtonActive));

      return _react2.default.createElement(
        'span',
        { onMouseDown: onMouseDown, style: style },
        _react2.default.createElement(
          'span',
          null,
          icon
        )
      );
    }, _this.renderBlockButton = function (type, icon) {
      var child = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      var isActive = _this.props.hasBlock(type);

      var onMouseDown = function onMouseDown(e) {
        return _this.props.onBlockButtonClick(e, type);
      };

      var style = _extends({}, styles.formatButton, isActive && _extends({}, styles.formatButtonActive));

      return _react2.default.createElement(
        'span',
        {
          onMouseDown: onMouseDown,
          style: style
        },
        _react2.default.createElement(
          'span',
          null,
          icon
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FormatMenu, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactPortal2.default,
        { isOpened: true, onOpen: this.props.onFormatMenuOpen },
        _react2.default.createElement(
          'div',
          { style: styles.menuWrapper },
          _react2.default.createElement(
            'div',
            { style: styles.menu },
            this.renderBlockButton('paragraph', 'P'),
            this.renderBlockButton('heading1', 'H1'),
            this.renderBlockButton('heading2', 'H2'),
            this.renderBlockButton('unorderedList', 'ul', 'listItem'),
            this.renderBlockButton('orderedList', 'ol', 'listItem'),
            this.renderMarkButton('bold', 'B'),
            this.renderMarkButton('italic', 'I'),
            this.renderMarkButton('code', '</>'),
            this.renderLinkButton('link', '🔗')
          )
        )
      );
    }
  }]);

  return FormatMenu;
}(_react2.default.Component);

FormatMenu.propTypes = {
  onMarkButtonClick: _react2.default.PropTypes.func.isRequired,
  onBlockButtonClick: _react2.default.PropTypes.func.isRequired,
  onFormatMenuOpen: _react2.default.PropTypes.func.isRequired,
  hasMark: _react2.default.PropTypes.func.isRequired
};
exports.default = FormatMenu;