'use strict';

var fs = require('fs');
var path = require('path');

var packageJsonPath = path.resolve(process.cwd(), 'package.json');

var relativePath = 'index.js';

if (fs.existsSync(packageJsonPath)) {
  var packageFileContents = fs.readFileSync(packageJsonPath, 'utf-8');

  try {
    var main = JSON.parse(packageFileContents).main;

    if (main) {
      relativePath = main;
    }
  } catch (e) {
    throw new Error('package.json: ' + e.message);
  }
}

var configPath = path.resolve(process.cwd(), relativePath);

if (!fs.existsSync(configPath)) {
  throw new Error('Main script \'' + configPath + '\' does not exist');
}

module.exports = configPath;