'use strict';

var aws = require('aws-sdk');
var awsConfig = require('./config/aws');

module.exports = function (callback) {
  if (!awsConfig.s3Region || !awsConfig.s3Bucket) {
    return callback({});
  }

  new aws.S3({
    region: awsConfig.s3Region
  }).makeUnauthenticatedRequest('getObject', {
    Bucket: awsConfig.s3Bucket,
    Key: 'content.json'
  }, function (err, data) {
    if (err) {
      callback(err);
    } else {
      callback(null, JSON.parse(data.Body.toString()));
    }
  });
};