"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getAssetsFromCompilation;
function getAssetsFromCompilation(compilation) {
  var stats = compilation.getStats().toJson();

  var assets = {};

  for (var chunk in stats.assetsByChunkName) {
    var chunkValue = stats.assetsByChunkName[chunk];

    // Webpack outputs an array for each chunk when using sourcemaps
    if (chunkValue instanceof Array) {
      // Is the main bundle always the first element?
      chunkValue = chunkValue[0];
    }

    if (compilation.options.output.publicPath) {
      chunkValue = compilation.options.output.publicPath + chunkValue;
    }
    assets[chunk] = chunkValue;
  }

  return assets;
}