'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = authentication;
var initialState = {
  credentials: null,
  error: null,
  signingIn: false,
  fetchingCredentials: false
};

function authentication() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case 'FETCH_CREDENTIALS':
      return _extends({}, state, {
        fetchingCredentials: true
      });

    case 'FETCH_CREDENTIALS_SUCCESS':
      return _extends({}, state, {
        credentials: action.credentials,
        fetchingCredentials: false
      });

    case 'FETCH_CREDENTIALS_FAILURE':
      return _extends({}, state, {
        credentials: false,
        fetchingCredentials: false
      });

    case 'SIGN_IN':
      return _extends({}, state, {
        signingIn: true,
        error: null
      });

    case 'SIGN_IN_SUCCESS':
      return _extends({}, state, {
        signingIn: false,
        credentials: action.credentials
      });

    case 'SIGN_IN_ERROR':
      return _extends({}, state, {
        signingIn: false,
        error: action.error
      });

    case 'SIGN_OUT':
      return _extends({}, state, {
        credentials: false
      });
  }

  return state;
}