'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = content;

var _immutable = require('immutable');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {
  published: (0, _immutable.Map)({}),
  session: (0, _immutable.Map)({}),
  uploads: {}
};

function content() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case 'SET':
      var path = action.path.split('/');

      return _extends({}, state, {
        session: state.session.updateIn(path, function () {
          return (0, _immutable.fromJS)(action.value);
        })
      });

    case 'SET_FILE_UPLOAD':
      return _extends({}, state, {
        uploads: _extends({}, state.uploads, _defineProperty({}, action.key, {
          files: action.files,
          preview: action.preview
        }))
      });

    case 'DISCARD':
      return _extends({}, state, {
        session: state.published,
        uploads: {}
      });

    case 'RELEASE_SUCCESS':
      return _extends({}, state, {
        published: state.session,
        uploads: {}
      });
  }

  return state;
}