'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = editor;
var initialState = {
  editing: false,
  publishing: false,
  building: false,
  uploading: false,
  releasing: false
};

function editor() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case 'TOGGLE_EDITING':
      return _extends({}, state, {
        editing: !state.editing
      });

    case 'PUBLISH':
      return _extends({}, state, {
        publishing: true,
        editing: false
      });

    case 'PUBLISH_SUCCESS':
      return _extends({}, state, {
        publishing: false
      });

    case 'BUILD':
      return _extends({}, state, {
        building: true
      });

    case 'BUILD_SUCCESS':
      return _extends({}, state, {
        building: false
      });

    case 'UPLOAD':
      return _extends({}, state, {
        uploading: true
      });

    case 'UPLOAD_SUCCESS':
      return _extends({}, state, {
        uploading: false
      });

    case 'RELEASE':
      return _extends({}, state, {
        releasing: true
      });

    case 'RELEASE_SUCCESS':
      return _extends({}, state, {
        releasing: false
      });
  }

  return state;
}