'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _path3 = require('./config/path');

var _path4 = _interopRequireDefault(_path3);

var _aws = require('./config/aws');

var _aws2 = _interopRequireDefault(_aws);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

process.noDeprecation = true;

var projectBabelConfigPath = _path2.default.resolve(process.cwd(), '.babelrc');
var babelOptions = {};

if (_fs2.default.existsSync(projectBabelConfigPath)) {
  babelOptions.babelrc = projectBabelConfigPath;
} else {
  babelOptions.presets = [require.resolve('babel-preset-es2015'), require.resolve('babel-preset-react')];
}

module.exports = {
  entry: {
    client: _path2.default.resolve(__dirname, 'client.js')
  },

  output: {
    path: _path2.default.resolve(process.cwd(), '.flatpack'),
    filename: '[name].js',
    chunkFilename: '[name].js',
    publicPath: '/'
  },

  module: {
    rules: [{
      test: /\.jsx?$/,
      exclude: /node_modules/,
      use: [{
        loader: require.resolve('babel-loader'),
        options: babelOptions
      }]
    }]
  },

  resolve: {
    modules: [_path2.default.resolve(process.cwd(), 'node_modules'), _path2.default.resolve(__dirname, '..', 'node_modules')],
    alias: {
      config: _path4.default
    }
  },

  plugins: [new _webpack2.default.DefinePlugin({
    'window.aws': JSON.stringify(_aws2.default)
  })]
};