'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _FileWriterWebpackPlugin = require('./FileWriterWebpackPlugin');

var _FileWriterWebpackPlugin2 = _interopRequireDefault(_FileWriterWebpackPlugin);

var _getAssetsFromCompilation = require('./getAssetsFromCompilation');

var _getAssetsFromCompilation2 = _interopRequireDefault(_getAssetsFromCompilation);

var _fetchRemoteContent = require('./fetchRemoteContent');

var _fetchRemoteContent2 = _interopRequireDefault(_fetchRemoteContent);

var _renderRoutes = require('./renderRoutes');

var _renderRoutes2 = _interopRequireDefault(_renderRoutes);

var _get = require('./config/get');

var _get2 = _interopRequireDefault(_get);

var _webpackCommon = require('./webpack.common.config');

var _webpackCommon2 = _interopRequireDefault(_webpackCommon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

module.exports = _extends({}, _webpackCommon2.default, {

  devtool: 'source-map',

  output: {
    path: _path2.default.resolve(process.cwd(), 'build'),
    filename: '[name].js',
    chunkFilename: '[name].js',
    publicPath: '/'
  },

  plugins: [].concat(_toConsumableArray(_webpackCommon2.default.plugins), [new _webpack2.default.DefinePlugin({
    'process.env.NODE_ENV': JSON.stringify('development')
  }), new _FileWriterWebpackPlugin2.default(function (compilation, callback) {
    var assets = (0, _getAssetsFromCompilation2.default)(compilation);
    var scripts = [assets.client];

    // Clear require cache
    Object.keys(require.cache).forEach(function (key) {
      if (!/node_modules/.test(key)) {
        delete require.cache[key];
      }
    });

    (0, _get2.default)(function (err, config) {
      if (err) {
        return callback(err);
      }

      (0, _fetchRemoteContent2.default)(function (err, content) {
        if (err) {
          return callback(err);
        }

        (0, _renderRoutes2.default)({ config: config, content: content, scripts: scripts }, function (err, files) {
          if (err) {
            return callback(err);
          }

          callback(null, files);
        });
      });
    });
  })])
});